#pragma once
#include <Result.h>

struct Registers;

namespace CPU
{
    Result<const char*> identify();
    const char* platform_string();

    void platform_init();
    void platform_finish_init();

    [[noreturn]] void efficient_halt();

    void switch_kernel_stack(u64 top);

    void enable_interrupts();
    void disable_interrupts();
    void wait_for_interrupt();
}